server/cheeses/urls.py
from django.urls import path

from . import views

app_name = "cheeses"

urlpatterns = [
    path("", views.CheeseListView.as_view(), name="list"),
    path("add/", views.CheeseCreateView.as_view(), name="add"),
    path("<slug:slug>/", views.CheeseDetailView.as_view(), name="detail"),
]

server/core/urls.py
from django.urls import path

from .views import HomePageView, csv_view, pdf_view, MyView

urlpatterns = [
    path("", HomePageView.as_view(), name="home_page"),
    path("csv-view/", csv_view, name="csv_view"),
    path("pdf-view/", pdf_view, name="some_view"),
    path("my-view/", MyView.as_view(), name="my_view"),
]

server/django_project/urls.py
from django.contrib import admin
from django.urls import include, path

from .views import ping

urlpatterns = [
    path("admin/", admin.site.urls),
    path("cheeses/", include("cheeses.urls", namespace="cheeses")),
    path("ping/", ping, name="ping"),
    path("", include("core.urls")),
    path("", include("movies.urls")),
]

server/movies/urls.py
from django.urls import path

from .views import MovieDetail, MovieList, Foo


urlpatterns = [
    path("api/movies/", MovieList.as_view()),
    path("api/movies/<int:pk>/", MovieDetail.as_view()),
    path("api/foo/", Foo.as_view()),
]

server/cheeses/models.py
from autoslug import AutoSlugField
from django.db import models
from django.urls import reverse
from django_countries.fields import CountryField
from model_utils.models import TimeStampedModel


class Cheese(TimeStampedModel):
    class Firmness(models.TextChoices):
        HARD = "hard", "Hard"
        SEMI_HARD = "semi-hard", "Semi-Hard"
        SEMI_SOFT = "semi-soft", "Semi-Soft"
        SOFT = "soft", "Soft"
        UNSPECIFIED = "unspecified", "Unspecified"

    country_of_origin = CountryField("Country of Origin", blank=True)
    description = models.TextField("Description", blank=True)
    firmness = models.CharField(
        "Firmness",
        choices=Firmness.choices,
        default=Firmness.UNSPECIFIED,
        max_length=20,
    )
    name = models.CharField("Name of Cheese", max_length=255)
    slug = AutoSlugField(
        "Cheese Address", always_update=False, populate_from="name", unique=True
    )

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        """Return absolute URL to the Cheese Detail page."""
        return reverse("cheeses:detail", kwargs={"slug": self.slug})

server/movies/models.py
from django.db import models


class Movie(models.Model):
    created_date = models.DateTimeField(auto_now_add=True)
    genre = models.CharField(max_length=255)
    title = models.CharField(max_length=255)
    year = models.CharField(max_length=4)
    updated_date = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.title

server/users/models.py
from django.contrib.auth.models import AbstractUser


class CustomUser(AbstractUser):
    pass

server/cheeses/views.py
from django.views.generic import CreateView, DetailView, ListView

from .models import Cheese


class CheeseCreateView(CreateView):
    fields = ["name", "description", "firmness", "country_of_origin"]
    model = Cheese


class CheeseDetailView(DetailView):
    model = Cheese


class CheeseListView(ListView):
    model = Cheese

server/core/views.py
import io
import csv

from django.http import FileResponse, HttpResponse
from django.views.generic import TemplateView, View
from reportlab.lib.pagesizes import A4
from reportlab.lib.units import inch
from reportlab.pdfgen import canvas

from movies.models import Movie


class HomePageView(TemplateView):
    template_name = "index.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["my_statement"] = "Nice to see you!"

        return context

    def say_bye(self):
        return "Goodbye!"


def csv_view(request):
    response = HttpResponse(
        content_type="text/csv",
        headers={"Content-Disposition": 'attachment; filename="somefilename.csv"'},
    )
    writer = csv.writer(response)

    writer.writerow(["Genre", "Title", "Movie"])

    for movie in Movie.objects.all():
        writer.writerow([movie.genre, movie.title, movie.year])

    return response


def pdf_view(request):
    buffer = io.BytesIO()
    c = canvas.Canvas(buffer, pagesize=A4)

    c.setAuthor("Marcus Farcus")
    c.translate(inch, inch)
    c.setFont("Helvetica", 14)
    c.setStrokeColorRGB(0.2, 0.5, 0.3)
    c.setFillColorRGB(1, 0, 1)
    c.line(0, 0, 0, 1.7 * inch)
    c.line(0, 0, inch, 0)
    c.rect(0.2 * inch, 0.2 * inch, 1 * inch, 1.5 * inch, fill=1)
    c.rotate(90)
    c.setFillColorRGB(0, 0, 0.77)
    c.drawString(0.3 * inch, -inch, "Hello, World!")

    c.showPage()
    c.save()

    c.translate(inch, inch)
    c.setFont("Helvetica", 14)
    c.setStrokeColorRGB(0.2, 0.5, 0.3)
    c.setFillColorRGB(1, 0, 1)
    c.line(0, 0, 0, 1.7 * inch)
    c.line(0, 0, inch, 0)
    c.rect(0.2 * inch, 0.2 * inch, 1 * inch, 1.5 * inch, fill=1)
    c.rotate(90)
    c.setFillColorRGB(0, 0, 0.77)
    c.drawString(0.3 * inch, -inch, "Hello, World!")

    buffer.seek(0)

    return FileResponse(buffer, as_attachment=True, filename="hello.pdf")


class MyView(View):
    def delete(self, request, *args, **kwargs):
        return HttpResponse("Response to DELETE request.")

    def get(self, request, *args, **kwargs):
        return HttpResponse("Response to GET request.")

    def post(self, request, *args, **kwargs):
        return HttpResponse("Response to POST request.")

server/django_project/views.py
from django.http import JsonResponse


def ping(request):
    data = {"ping": "pong!"}

    return JsonResponse(data)

server/movies/views.py
from django.shortcuts import get_object_or_404

from rest_framework import status
from rest_framework.response import Response
from rest_framework.views import APIView

from .models import Movie
from .serializers import MovieSerializer


class MovieDetail(APIView):
    def delete(self, request, pk, format=None):
        movie = get_object_or_404(Movie, pk=pk)
        movie.delete()

        return Response(status=status.HTTP_204_NO_CONTENT)

    def get(self, request, pk, format=None):
        movie = get_object_or_404(Movie, pk=pk)
        serializer = MovieSerializer(movie)

        return Response(serializer.data)

    def put(self, request, pk, format=None):
        movie = get_object_or_404(Movie, pk=pk)
        serializer = MovieSerializer(movie, data=request.data)

        if serializer.is_valid():
            serializer.save()

            return Response(serializer.data)

        return Response(serializer.errors, status=status.HTTP_400_BAD_REQUEST)


class MovieList(APIView):
    def get(self, request, format=None):
        movies = Movie.objects.all()
        serializer = MovieSerializer(movies, many=True)

        return Response(serializer.data)

    def post(self, request, format=None):
        serializer = MovieSerializer(data=request.data)

        if serializer.is_valid():
            serializer.save()

            return Response(serializer.data, status=status.HTTP_201_CREATED)

        return Response(serializer.errors, status=status.HTTP_400_BAD_REQUEST)


class Foo(APIView):
    def get(self, request, format=None):
        return Response({"number": False})

    def post(self, request, format=None):
        return Response(request.data)

server/templates/_base.html
{% load static %}
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>{% block title %}{% endblock %}</title>
    <link rel="stylesheet" href="{% static 'css/styles.css' %}">
</head>
<body>
{% block content %}
{% endblock %}
</body>
</html>

server/templates/cheeses/cheese_detail.html
{% load static %}
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Cheese - {{ cheese.name }}</title>
    <link rel="stylesheet" href="{% static 'flags/sprite.css' %}">
</head>
<body>
<h1>{{ cheese.name }} - {{ cheese.firmness }}</h1>

{% if cheese.country_of_origin %}
    <p>
        Country of Origin: {{ cheese.country_of_origin.name }} <i class="{{ cheese.country_of_origin.flag_css }}"></i>
    </p>
{% endif %}

{% if cheese.firmness %}
    <p>Firmness: {{ cheese.get_firmness_display }}</p>
{% endif %}

{% if cheese.description %}
    <p>{{ cheese.description }}</p>
{% endif %}

<p><a href="{% url 'cheeses:list' %}">Go Back to Cheese List</a></p>
</body>
</html>

server/templates/cheeses/cheese_form.html
{% extends "_base.html" %}

{% block title %}Add Cheese{% endblock %}

{% block content %}
    <h1>Add Cheese</h1>
    <form action="{% url 'cheeses:add' %}" method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit">Save</button>
    </form>
{% endblock %}

server/templates/cheeses/cheese_list.html
{% extends "_base.html" %}

{% block title %}Cheese List{% endblock %}

{% block content %}
    <h1>Cheese List</h1>
    {% for cheese in cheese_list %}
        <li>
            <a href="{% url 'cheeses:detail' cheese.slug %}">{{ cheese.name }}</a>
        </li>
    {% endfor %}
    <hr>
    <p>Don't see a cheese listed here?</p>
    <a href="{% url 'cheeses:add' %}">Add Cheese</a>
{% endblock %}

server/templates/index.html
{% extends "_base.html" %}

{% block content %}
    <h1>Hello, World!</h1>
    <p>{{ my_statement }}</p>
    <p>{{ view.say_bye }}</p>
    <p>
        <a href="{% url 'cheeses:list' %}">List o' Cheeses</a>
    </p>
{% endblock %}